import { http } from '@/api/service/request';
import type { BaseResult, ResultTable } from '@/api/service/types';

/** 账单信息---获取账单信息列表 */
export const fetchGetBillList = (data: any) => {
	data = {
		userId: data.userId,
		amount: data.amount,
		type: data.type,
		description: data.description,
		startDate: data.startDate,
		endDate: data.endDate,
		pageSize: data.pageSize,
		currentPage: data.currentPage,
	};
	return http.request<BaseResult<ResultTable>>('get', `bill/getBillList/${data.currentPage}/${data.pageSize}`, { params: data });
};

/** 账单信息---导出用户账单信息 */
export const fetchExportBill = (data: any) => {
	return http.request<BaseResult<object>>('post', 'bill/exportBillByAdmin', { data, responseType: 'blob' });
};

/** 账单信息---添加账单信息 */
export const fetchAddBill = (data: any) => {
	return http.request<BaseResult<object>>('post', 'bill/addBill', { data });
};

/** 账单信息---更新账单信息 */
export const fetchUpdateBill = (data: any) => {
	return http.request<BaseResult<object>>('put', 'bill/updateBill', { data });
};

/** 账单信息---删除账单信息 */
export const fetchDeleteBill = (data: any) => {
	return http.request<BaseResult<object>>('delete', 'bill/deleteBill', { data });
};
