import { http } from '@/api/service/request';
import type { BaseResult, ResultTable } from '@/api/service/types';

/** 预算分类表---获取预算分类表列表 */
export const fetchGetBudgetCategoryList = (data: any) => {
	return http.request<BaseResult<ResultTable>>('get', `budgetCategory/getBudgetCategoryList/${data.currentPage}/${data.pageSize}`, { params: data });
};

/** 预算分类表---返回所有父级对象 */
export const fetchGetAllParentList = () => {
	return http.request<BaseResult<object>>('get', 'budgetCategory/noManage/getAllParentList');
};

/** 预算分类表---添加预算分类表 */
export const fetchAddBudgetCategory = (data: any) => {
	return http.request<BaseResult<object>>('post', 'budgetCategory/addBudgetCategory', { data });
};

/** 预算分类表---更新预算分类表 */
export const fetchUpdateBudgetCategory = (data: any) => {
	return http.request<BaseResult<object>>('put', 'budgetCategory/updateBudgetCategory', { data });
};

/** 预算分类表---删除预算分类表 */
export const fetchDeleteBudgetCategory = (data: any) => {
	return http.request<BaseResult<object>>('delete', 'budgetCategory/deleteBudgetCategory', { data });
};
