import { http } from '@/api/service/request';
import type { BaseResult, ResultTable } from '@/api/service/types';

/** 分类信息---获取分类信息列表 */
export const fetchGetCategoryList = (data: any) => {
	return http.request<BaseResult<ResultTable>>('get', `category/getCategoryList/${data.currentPage}/${data.pageSize}`, { params: data });
};

/** 分类信息---查询当前用户下所有的分类 */
export const fetchGetCategoryAllList = (data: any) => {
	return http.request<BaseResult<object>>('get', 'category/noManage/getCategoryUserAllList', { params: data });
};

/** 分类信息---添加分类信息 */
export const fetchAddCategory = (data: any) => {
	return http.request<BaseResult<object>>('post', 'category/addCategory', { data });
};

/** 分类信息---更新分类信息 */
export const fetchUpdateCategory = (data: any) => {
	return http.request<BaseResult<object>>('put', 'category/updateCategory', { data });
};

/** 分类信息---删除分类信息 */
export const fetchDeleteCategory = (data: any) => {
	return http.request<BaseResult<object>>('delete', 'category/deleteCategory', { data });
};
