import { http } from '@/api/service/request';
import type { BaseResult, ResultTable } from '@/api/service/types';

/** 债务还款计划表---获取债务还款计划表列表 */
export const fetchGetDebtRepaymentPlanList = (data: any) => {
	return http.request<BaseResult<ResultTable>>('get', `debtRepaymentPlan/getDebtRepaymentPlanList/${data.currentPage}/${data.pageSize}`, { params: data });
};

/** 债务还款计划表---添加债务还款计划表 */
export const fetchAddDebtRepaymentPlan = (data: any) => {
	return http.request<BaseResult<object>>('post', 'debtRepaymentPlan/addDebtRepaymentPlan', { data });
};

/** 债务还款计划表---更新债务还款计划表 */
export const fetchUpdateDebtRepaymentPlan = (data: any) => {
	return http.request<BaseResult<object>>('put', 'debtRepaymentPlan/updateDebtRepaymentPlan', { data });
};

/** 债务还款计划表---删除债务还款计划表 */
export const fetchDeleteDebtRepaymentPlan = (data: any) => {
	return http.request<BaseResult<object>>('delete', 'debtRepaymentPlan/deleteDebtRepaymentPlan', { data });
};
