import { http } from '@/api/service/request';
import type { BaseResult, ResultTable } from '@/api/service/types';

/** 债务追踪---获取债务追踪列表 */
export const fetchGetDebtTrackingList = (data: any) => {
	return http.request<BaseResult<ResultTable>>('get', `debtTracking/getDebtTrackingList/${data.currentPage}/${data.pageSize}`, { params: data });
};

/** 债务追踪---添加债务追踪 */
export const fetchAddDebtTracking = (data: any) => {
	return http.request<BaseResult<object>>('post', 'debtTracking/addDebtTracking', { data });
};

/** 债务追踪---更新债务追踪 */
export const fetchUpdateDebtTracking = (data: any) => {
	return http.request<BaseResult<object>>('put', 'debtTracking/updateDebtTracking', { data });
};

/** 债务追踪---删除债务追踪 */
export const fetchDeleteDebtTracking = (data: any) => {
	return http.request<BaseResult<object>>('delete', 'debtTracking/deleteDebtTracking', { data });
};
