import { http } from '@/api/service/request';
import type { BaseResult, ResultTable } from '@/api/service/types';

/** 账单信息---获取账单信息列表 */
export const fetchGetUserBillList = (data: any) => {
	data = {
		amount: data.amount,
		type: data.type,
		description: data.description,
		startDate: data.startDate,
		endDate: data.endDate,
		pageSize: data.pageSize,
		currentPage: data.currentPage,
	};
	return http.request<BaseResult<ResultTable>>('get', `bill/noManage/getUserBillList/${data.currentPage}/${data.pageSize}`, { params: data });
};

/** 账单信息---账单收入和支出 */
export const fetchGetExpendOrIncome = (data: any) => {
	data = { userId: data.userId, type: data.type, startDate: data.startDate, endDate: data.endDate };
	return http.request<BaseResult<object>>('get', 'bill/noManage/getExpendOrIncome', {
		params: data,
	});
};

/** 账单信息---导出用户账单信息 */
export const fetchImportBill = (data: any) => {
	return http.request<BaseResult<object>>('post', 'bill/noManage/importBill', {
		data,
		headers: { 'Content-Type': 'multipart/form-data' },
	});
};

/** 账单信息---导出用户账单信息 */
export const fetchExportBill = (data: any) => {
	return http.request<BaseResult<object>>('post', 'bill/noManage/exportBill', { data, responseType: 'blob' });
};

/** 账单信息---添加账单信息 */
export const fetchAddUserBill = (data: any) => {
	return http.request<BaseResult<object>>('post', 'bill/noManage/addUserBill', { data });
};

/** 账单信息---更新账单信息 */
export const fetchUpdateUserBill = (data: any) => {
	return http.request<BaseResult<object>>('put', 'bill/noManage/updateUserBill', { data });
};

/** 账单信息---删除账单信息 */
export const fetchDeleteUserBill = (data: any) => {
	return http.request<BaseResult<object>>('delete', 'bill/noManage/deleteUserBill', { data });
};
