import { http } from '@/api/service/request';
import type { BaseResult, ResultTable } from '@/api/service/types';

/** 预算分类表---获取预算分类表列表 */
export const fetchGetUserBudgetCategoryList = (data: any) => {
	return http.request<BaseResult<ResultTable>>('get', `budgetCategory/noManage/getUserBudgetCategoryList/${data.currentPage}/${data.pageSize}`, {
		params: data,
	});
};

/** 预算分类表---返回当前用户所有父级对象 */
export const fetchGetAllUserParentList = () => {
	return http.request<BaseResult<object>>('get', 'budgetCategory/noManage/getAllUserParentList');
};

/** 预算分类表---添加预算分类表 */
export const fetchAddUserBudgetCategory = (data: any) => {
	return http.request<BaseResult<object>>('post', 'budgetCategory/noManage/addUserBudgetCategory', { data });
};

/** 预算分类表---更新预算分类表 */
export const fetchUpdateUserBudgetCategory = (data: any) => {
	return http.request<BaseResult<object>>('put', 'budgetCategory/noManage/updateUserBudgetCategory', { data });
};

/** 预算分类表---删除预算分类表 */
export const fetchDeleteUserBudgetCategory = (data: any) => {
	return http.request<BaseResult<object>>('delete', 'budgetCategory/noManage/deleteUserBudgetCategory', { data });
};
