import { http } from '@/api/service/request';
import type { BaseResult, ResultTable } from '@/api/service/types';

/** 债务还款计划表---获取债务还款计划表列表 */
export const fetchGetUserDebtRepaymentPlanList = (data: any) => {
	return http.request<BaseResult<ResultTable>>('get', `debtRepaymentPlan/noManage/getUserDebtRepaymentPlanList/${data.currentPage}/${data.pageSize}`, {
		params: data,
	});
};

/** 债务还款计划表---添加债务还款计划表 */
export const fetchAddUserDebtRepaymentPlan = (data: any) => {
	return http.request<BaseResult<object>>('post', 'debtRepaymentPlan/noManage/addUserDebtRepaymentPlan', { data });
};

/** 债务还款计划表---更新债务还款计划表 */
export const fetchUpdateUserDebtRepaymentPlan = (data: any) => {
	return http.request<BaseResult<object>>('put', 'debtRepaymentPlan/noManage/updateUserDebtRepaymentPlan', { data });
};

/** 债务还款计划表---删除债务还款计划表 */
export const fetchDeleteUserDebtRepaymentPlan = (data: any) => {
	return http.request<BaseResult<object>>('delete', 'debtRepaymentPlan/noManage/deleteUserDebtRepaymentPlan', { data });
};
