import { http } from '@/api/service/request';
import type { BaseResult, ResultTable } from '@/api/service/types';

/** 债务追踪---获取债务追踪列表 */
export const fetchGetUserDebtTrackingList = (data: any) => {
	return http.request<BaseResult<ResultTable>>('get', `debtTracking/noManage/getUserDebtTrackingList/${data.currentPage}/${data.pageSize}`, { params: data });
};

/** 债务追踪---添加债务追踪 */
export const fetchAddUserDebtTracking = (data: any) => {
	return http.request<BaseResult<object>>('post', 'debtTracking/noManage/addUserDebtTracking', { data });
};

/** 债务追踪---更新债务追踪 */
export const fetchUpdateUserDebtTracking = (data: any) => {
	return http.request<BaseResult<object>>('put', 'debtTracking/noManage/updateUserDebtTracking', { data });
};

/** 债务追踪---删除债务追踪 */
export const fetchDeleteUserDebtTracking = (data: any) => {
	return http.request<BaseResult<object>>('delete', 'debtTracking/noManage/deleteUserDebtTracking', { data });
};
