import { $t } from '@/plugins/i18n';

export const columns: TableColumnList = [
	{ type: 'index', index: (index: number) => index + 1, label: '序号', width: 60 },
	// 金额
	{
		label: $t('amount'),
		prop: 'amount',
		sortable: true,
		formatter({ type, amount }) {
			return type === -1 ? (
				<ElText size={'large'} type={'danger'} style={{ fontWeight: 800 }}>
					- {amount}￥
				</ElText>
			) : (
				<ElText size={'large'} type={'success'} style={{ fontWeight: 800 }}>
					+ {amount}￥
				</ElText>
			);
		},
		width: 200,
	},
	// 类别
	{
		label: $t('categoryName'),
		prop: 'categoryName',
		width: 150,
		formatter({ categoryName }) {
			return <ElTag effect={'plain'}>{categoryName}</ElTag>;
		},
	},
	// 描述
	{ label: $t('description'), prop: 'description' },
	// 交易日期
	{
		label: $t('transactionDate'),
		prop: 'transactionDate',
		width: 190,
		sortable: true,
		formatter({ transactionDate }) {
			return (
				<ElText type={'success'} style={{ fontWeight: 800 }}>
					{transactionDate}
				</ElText>
			);
		},
	},
];
