import { $t } from '@/plugins/i18n';
import { ElTag } from 'element-plus';

export const debtType = [
	// 信用卡债务
	{
		value: 'CreditCardDebt',
		label: $t('creditCardDebt'),
		el: () => (
			<ElTag type={'primary'} effect={'plain'}>
				{$t('creditCardDebt')}
			</ElTag>
		),
	},
	// 贷款债务
	{
		value: 'LoanDebt',
		label: $t('loanDebt'),
		el: () => (
			<ElTag type={'primary'} effect={'plain'}>
				{$t('loanDebt')}
			</ElTag>
		),
	},
	// 抵押债务
	{
		value: 'MortgageDebt',
		label: $t('mortgageDebt'),
		el: () => (
			<ElTag type={'primary'} effect={'plain'}>
				{$t('mortgageDebt')}
			</ElTag>
		),
	},
	// 学生贷款
	{
		value: 'StudentLoans',
		label: $t('studentLoans'),
		el: () => (
			<ElTag type={'primary'} effect={'plain'}>
				{$t('studentLoans')}
			</ElTag>
		),
	},
	// 医疗债务
	{
		value: 'MedicalDebt',
		label: $t('medicalDebt'),
		el: () => (
			<ElTag type={'primary'} effect={'plain'}>
				{$t('medicalDebt')}
			</ElTag>
		),
	},
	// 透支债务
	{
		value: 'OverdraftDebt',
		label: $t('overdraftDebt'),
		el: () => (
			<ElTag type={'primary'} effect={'plain'}>
				{$t('overdraftDebt')}
			</ElTag>
		),
	},
	// 私人借款
	{
		value: 'PrivateBorrowing',
		label: $t('privateBorrowing'),
		el: () => (
			<ElTag type={'primary'} effect={'plain'}>
				{$t('privateBorrowing')}
			</ElTag>
		),
	},
	// 其他债务
	{
		value: 'OtherDebts',
		label: $t('otherDebts'),
		el: () => (
			<ElTag type={'primary'} effect={'plain'}>
				{$t('otherDebts')}
			</ElTag>
		),
	},
];

export const debtTracking = [
	{
		value: 'InProgress',
		label: $t('inProgress'),
		el: () => (
			<ElTag type={'primary'} effect={'plain'}>
				{$t('inProgress')}
			</ElTag>
		),
	},
	{
		value: 'Uncompleted',
		label: $t('uncompleted'),
		el: () => (
			<ElTag type={'primary'} effect={'plain'}>
				{$t('uncompleted')}
			</ElTag>
		),
	},
	{
		value: 'Completed',
		label: $t('completed'),
		el: () => (
			<ElTag type={'success'} effect={'plain'}>
				{$t('completed')}
			</ElTag>
		),
	},
	{
		value: 'NotStarted',
		label: $t('notStarted'),
		el: () => (
			<ElTag type={'warning'} effect={'plain'}>
				{$t('notStarted')}
			</ElTag>
		),
	},
	{
		value: 'OverSpending',
		label: $t('overSpending'),
		el: () => (
			<ElTag type={'danger'} effect={'plain'}>
				{$t('overSpending')}
			</ElTag>
		),
	},
	{
		value: 'Pause',
		label: $t('pause'),
		el: () => (
			<ElTag type={'warning'} effect={'plain'}>
				{$t('pause')}
			</ElTag>
		),
	},
	{
		value: 'Cancel',
		label: $t('cancel'),
		el: () => (
			<ElTag type={'info'} effect={'plain'}>
				{$t('cancel')}
			</ElTag>
		),
	},
];
