export default [
	// financial管理
	{
		path: '/financial-user',
		name: 'FinancialUser',
		redirect: '/financial-user/bill',
		meta: {
			icon: 'mdi:finance',
			title: 'financialManagement',
			rank: 1,
		},
		children: [
			// 账单概览
			{
				path: '/financial-user/bill',
				name: 'BillUser',
				component: () => import('@/views/financial-user/account-bill/bill/index.vue'),
				meta: {
					icon: 'grommet-icons:money',
					title: 'billManagement',
				},
			},

			// 支出分析
			{
				path: '/financial-user/expend',
				name: 'ExpendUser',
				component: () => import('@/views/financial-user/account-bill/expend/index.vue'),
				meta: {
					icon: 'icon-park-outline:expenses',
					title: 'expendAnalyse',
				},
			},
			// 收入分析
			{
				path: '/financial-user/income',
				name: 'IncomeUser',
				component: () => import('@/views/financial-user/account-bill/income/index.vue'),
				meta: {
					icon: 'icon-park-outline:income',
					title: 'incomeAnalyse',
				},
			},
			// 账单分类管理
			{
				path: '/financial-user/category',
				name: 'CategoryUser',
				component: () => import('@/views/financial-user/account-bill/category/index.vue'),
				meta: {
					icon: 'iconamoon:category',
					title: 'categoryUserManagement',
				},
			},
		],
	},
	// budget和savingGoal
	{
		path: '/budget-saving-user',
		name: 'BudgetSavingsUser',
		redirect: '/budget-saving-user/budget-category',
		meta: {
			icon: 'arcticons:budgetbakers-wallet',
			title: 'budgetSavings',
			rank: 1,
		},
		children: [
			// 预算分类
			{
				path: '/budget-saving-user/budget-category',
				name: 'budgetCategoryUser',
				component: () => import('@/views/financial-user/budget-saving/budget-category/index.vue'),
				meta: {
					icon: 'simple-icons:actualbudget',
					title: 'budgetCategory',
				},
			},
			// 预算储值
			{
				path: '/budget-saving-user/saving-goal',
				name: 'savingGoalUser',
				component: () => import('@/views/financial-user/budget-saving/saving-goal/index.vue'),
				meta: {
					icon: 'fluent:savings-16-regular',
					title: 'savingGoal',
				},
			},
		],
	},
	// Debt管理
	{
		path: '/debt-user',
		name: 'DebtManagementUser',
		redirect: '/debt-user/debt-tracking',
		meta: {
			icon: 'arcticons:debtcalc',
			title: 'debtManagement',
			rank: 1,
		},
		children: [
			// 债务还款计划
			{
				path: '/debt-user/debt-repayment-plan',
				name: 'debtRepaymentPlanUser',
				component: () => import('@/views/financial-user/debt/debt-repayment-plan/index.vue'),
				meta: {
					icon: 'stash:plan-light',
					title: 'debtRepaymentPlan',
				},
			},
			// 债务追踪
			{
				path: '/debt-user/debt-tracking',
				name: 'debtTrackingUser',
				component: () => import('@/views/financial-user/debt/debt-tracking/index.vue'),
				meta: {
					icon: 'ic:outline-spatial-tracking',
					title: 'debtTracking',
				},
			},
		],
	},
] satisfies Array<RouteConfigsTable>;
