import dayjs from 'dayjs';
import { currentMouth } from '@/enums/dateEnums';

/** 设置默认时间 */
export const getDefaultDateRange = (start = 1, end = 7) => {
	const today = new Date();
	// 结束日期为今天
	const endDate = new Date();
	endDate.setDate(endDate.getDate() + start);
	// 开始日期初始化为今天
	const startDate = new Date(today);

	// 往前推7天
	startDate.setDate(today.getDate() - end);

	return [dayjs(startDate).format('YYYY-MM-DD'), dayjs(endDate).format('YYYY-MM-DD')];
};

/** 获取当前月的日期*/
export const getCurrentMouthDate = () => {
	const start = currentMouth[0];
	const end = currentMouth[1];

	return [start.format('YYYY-MM-DD'), end.format('YYYY-MM-DD')];
};

/** 格式化日期 */
export const dateformat = (date: any) => {
	return dayjs(date).format('YYYY-MM-DD HH:mm:ss');
};
